/*******************************************************************************
 * Copyright (c) 2010, 2014 IBM Corp. and others
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution and
 * is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] http://openjdk.java.net/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0 WITH Classpath-exception-2.0 OR LicenseRef-GPL-2.0 WITH Assembly-exception
 *******************************************************************************/
package com.ibm.j9ddr.corereaders;

/**
 * A core file that is dependent on shared libraries
 * to complete its address space.
 * 
 * @author andhall
 *
 */
public interface ILibraryDependentCore extends ICore
{
	/**
	 * The system property which contains the full path to the executable.
	 * This can be set on the command line when it is not possible for the reader
	 * to deduce where the the exe is due to truncated core file entries.
	 */
	public static final String SYSTEM_PROP_EXE_PATH="com.ibm.j9ddr.corereaders.exepath";

	/**
	 * Give the core reader a hint to the location 
	 * of the executable. If it hasn't already found
	 * and loaded the libraries, may attempt to do so.
	 * @param path
	 */
	public void executablePathHint(String path);
}
